(function ($) {
  Drupal.behaviors.views_heirarchy_operations = function() {
    // Setup the hide/show functionality of the hierarchy.
    $(".views_hierarchy_op_fieldset").hide();
    $("a.views_hierarchy_op_expand_link").each(function() {
      if(!$(".views_hierarchy_op_fieldset_" + $(this).attr('href')).length) {
        $("img.views_hierarchy_op_expanded", this).hide();
        $("img.views_hierarchy_op_collapsed", this).hide();
      }
      else {
        $(this).unbind().click( function( event ) {
          event.preventDefault();
          var fieldset = $(".views_hierarchy_op_fieldset_" + $(this).attr('value'));
          if( fieldset.is(":visible") ) {
            fieldset.hide("fast");
            $("img.views_hierarchy_op_expanded", this).hide();
            $("img.views_hierarchy_op_collapsed", this).show();
          }
          else {
            fieldset.show("fast");
            $("img.views_hierarchy_op_expanded", this).show();
            $("img.views_hierarchy_op_collapsed", this).hide();
          }
        });
      }
    });

    // Declare our select all and select none strings.
    var strings = {
      'selectAll': Drupal.t('Select all rows in this table'),
      'selectNone': Drupal.t('Deselect all rows in this table')
    };

    // Find our views heirarchy operations code.
    $(".views_hierarchy_operations").each(function() {
      var _this = this;

      // Add a click handler on the select all input.
      $('input.vho-select-all-checkbox', this).unbind().click(function(event) {

        // Check to make sure this is an input.
        if ($(event.target).is('input:checkbox')) {

          // Get the checked state of this input.
          var checked = $(event.target).is(":checked");

          // Change the title of the checkbox depending on if it is checked or not.
          $(this).attr('title', checked ? strings.selectNone : strings.selectAll);

          // Now iterate through all inputs within this views hierarchy and select or delect.
          $("input", _this).each(function() {
            if( !$(this).hasClass('vho-select-all-checkbox') ) {
              $(this).attr('checked', checked);
            }
          });
        }
      });
    });

    Drupal.views_hierarchy_operations = {
      onClick: function( checkfield ) {
        // Make the child checkboxes reflect this parent checkbox.
        $("input." + $(checkfield).attr('parentselect')).attr('checked', $(checkfield).is(":checked"));
      }
    };
  }
})(jQuery);

